﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=5.82
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
	Public Const NaNd = $"$1.2{"The value is not a number!"}"$ As Double

'	Type stats_t(mean As Double, stdDev As Double, MinVal As Double, MaxVal As Double, range As Double)
	
'
'	Public tgbZoomBts As ToggleButton
End Sub


Sub ConvertHexStringToInt (Tx As String ) As Int
	Dim i As Int
	Dim Ty As String

	' Guarantee the required string length of 8  e.g. DAB89 => 000DAB89
	i = 8 - Tx.Length

	' ERROR string too Long (or write your own rules please)
	If i < 0 Then
		Return -1
	End If

	' if string is shorter -> fill string with leading Zeros
	If i > 0 Then
		Ty = "00000000".SubString2(0,i) & Tx
	Else
		Ty = Tx
	End If

	' And now lets go binary ;-)
	' convert the higher part first
	i = Bit.ParseInt (Ty.SubString2 (0,4),16)
	' correct the value (lower 16 bits are set to zero by the shift operation)
	i = Bit.ShiftLeft (i,16)
	' add the lower part and combine
	i = Bit.Or (i,Bit.ParseInt (Ty.SubString2 (4,8),16))

	Return i
End Sub

''Initializes the object. You can add parameters to this method if needed.
'Public Sub InitializePowerVarsView(TableView1 As TableView)
'	'set the columns
'	TableView1.SetColumns(Array As String("Parameter","Date", "Time", "Vrms", "Freq", "Powerwall kW", "Solar kW","Load kW","Supply KWHr","Solar kWHr","Load kWHr","Quality" ))
'
'	Dim row() As Object = CreateRow(Array As String("Instantaneous","#nan","#nan","#nan","#nan","#nan","#nan","#nan","#nan","#nan","#nan","#nan"))
'	TableView1.Items.Add(row)
'		
'	Dim row() As Object = CreateRow(Array As String("Mean       2 Hr","#nan","#nan","#nan","#nan","#nan","#nan","#nan","#nan","#nan","#nan","#nan"))
'	TableView1.Items.Add(row)
'		
'	Dim row() As Object = CreateRow(Array As String("Max        2 Hr","#nan","#nan","#nan","#nan","#nan","#nan","#nan","#nan","#nan","#nan","#nan"))
'	TableView1.Items.Add(row)
'		
'	Dim row() As Object = CreateRow(Array As String("Min        2 Hr","#nan","#nan","#nan","#nan","#nan","#nan","#nan","#nan","#nan","#nan","#nan"))
'	TableView1.Items.Add(row)
'			
'	Dim row() As Object = CreateRow(Array As String("Std Dev   2 Hr","#nan","#nan","#nan","#nan","#nan","","","","","",""))
'	TableView1.Items.Add(row)
'	
'	SetColumnStyle(0, "-fx-alignment: center-left;-fx-font-weight: BOLD", TableView1)
'	SetColumnStyle(3, "-fx-alignment: center-left;-fx-font-weight: BOLD", TableView1)
'End Sub
'
'
'Public Sub displayStats(TableView1 As TableView)
'	
'	Dim dateStr As String
'	Dim timeStr As String
'
'	Dim MeanV = 0 As Float
'	Dim MeanF = 0 As Float
'	Dim MeanP1 = 0 As Float
'	Dim MeanP2 = 0 As Float
'	Dim MeanP3 = 0 As Float
'	Dim MeanQ = 0 As Float
'	Dim cdr As calender_t
'
'	DateTime.DateFormat = "dd/MM/yyyy"
'	DateTime.TimeFormat = "HH : mm : ss"
'
'	If NWServ.displayUTC = True Then
'		cdr = dateTimeConversions.JD2CAL(NWServ.rtData_s.jTimeEmbed)
'		dateStr = DateTime.Date(cdr.ticks) & " UTC"
'		timeStr = DateTime.Time(cdr.ticks) & " UTC"
'	Else
'		cdr = dateTimeConversions.JD2CAL(NWServ.rtData_s.jTimeEmbed + 10 / 24)
'		dateStr = DateTime.Date(cdr.ticks) & " EST"
'		timeStr = DateTime.Time(cdr.ticks) & " EST"
'	End If
'
'	'Calculate moving average - sum the bins
'	For i = 0 To NWServ.movAvgStartCount - 1
'		MeanV 	= MeanV 	+ NWServ.arrayAvg_Vrms(i)
'		MeanF 	= MeanF 	+ NWServ.arrayAvg_Freq(i)
'		MeanP1 	= MeanP1 	+ NWServ.arrayAvg_P1(i)
'		MeanP2 	= MeanP2 	+ NWServ.arrayAvg_P2(i)
'		MeanP3 	= MeanP3 	+ NWServ.arrayAvg_P3(i)
'		MeanQ 	= MeanQ 	+ NWServ.arrayAvg_Quality(i)
'	Next
'	
'	'Normalise the moving average values
'	MeanV 	= MeanV / NWServ.movAvgStartCount
'	MeanF 	= MeanF / NWServ.movAvgStartCount
'	MeanP1 	= MeanP1 / NWServ.movAvgStartCount
'	MeanP2 	= MeanP2 / NWServ.movAvgStartCount
'	MeanP3 	= MeanP3 / NWServ.movAvgStartCount
'	MeanQ 	= MeanQ / NWServ.movAvgStartCount
'	
'	Dim row() As Object = CreateRow(Array As String("Instantaneous", _ 
'													dateStr, _
'													timeStr, _
'													NumberFormat(NWServ.rtData_s.Vrms,1,4), _ 
'													NumberFormat(NWServ.rtData_s.Frequency,1,6), _ 
'													NumberFormat(NWServ.rtData_s.P1,1,3), _ 
'													NumberFormat(NWServ.rtData_s.P2,1,3), _ 
'													NumberFormat(NWServ.rtData_s.P3,1,3), _
'													"#nan","#nan","#nan", _
'													NumberFormat(NWServ.Quality,1,3)))
'	TableView1.Items.Set(0,row)
'
'	Dim row() As Object = CreateRow(Array As String("Mean       10 Min", _
'													dateStr, _
'													timeStr, _
'													NumberFormat(MeanV,1,4), _ 
'													NumberFormat(MeanF,1,6), _ 
'													NumberFormat(MeanP1,1,3), _ 
'													NumberFormat(MeanP2,1,3), _ 
'													NumberFormat(MeanP3,1,3), _
'													"#nan","#nan","#nan", _
'													NumberFormat(MeanQ,1,3)))											
'	TableView1.Items.Set(1,row)
'
'
'	Dim row() As Object = CreateRow(Array As String("Max         10 Min", _
'													dateStr, _
'													timeStr, _
'													NumberFormat(NWServ.maxV,1,4), _ 
'													NumberFormat(NWServ.maxF,1,6), _ 
'													NumberFormat(NWServ.maxSupplykW,1,3), _ 
'													NumberFormat(NWServ.maxSolarkW,1,3), _ 
'													NumberFormat(NWServ.maxLoadkW,1,3), _
'													"#nan","#nan", "#nan", _
'													NumberFormat(NWServ.maxQuality,1,3)))												
'	TableView1.Items.Set(2,row)
'	
'	Dim row() As Object = CreateRow(Array As String("Min         10 Min", _
'													dateStr, _
'													timeStr, _
'													NumberFormat(NWServ.minV,1,4), _ 
'													NumberFormat(NWServ.minF,1,6), _ 
'													NumberFormat(NWServ.minSupplykW,1,3), _ 
'													NumberFormat(NWServ.minSolarkW,1,4), _ 
'													NumberFormat(NWServ.minLoadkW,1,3), _
'													"#nan","#nan", "#nan", _
'													NumberFormat(NWServ.minQuality,1,3)))											
'	TableView1.Items.Set(3,row)
'
'End Sub
'
'public Sub displayAlarms
'	If NWServ.alarmsIsInitialised = False Then
'
'	Else
'		NWServ.alarmsIsInitialised = True
'
'		NWServ.rtAlarms.flashMemError 		= NWServ.rtData_s.flashMemError 
'		NWServ.rtAlarms.freqMeasRefClkError = NWServ.rtData_s.freqMeasRefClkError 
'		NWServ.rtAlarms.realTimeProcError 	= NWServ.rtData_s.realTimeProcError 
'		NWServ.rtAlarms.freqMeasInputError 	= NWServ.rtData_s.freqMeasInputError 
'		
'		NWServ.rtAlarms.offsetLimitVrms 	= NWServ.rtData_s.offsetLimitVrms 
'		NWServ.rtAlarms.offsetLimitI1 		= NWServ.rtData_s.offsetLimitI1 
'		NWServ.rtAlarms.offsetLimitI2 		= NWServ.rtData_s.offsetLimitI2 
'		NWServ.rtAlarms.offsetLimitI3 		= NWServ.rtData_s.offsetLimitI3 
'		
'		NWServ.rtAlarms.refErrorVrms 		= NWServ.rtData_s.refErrorVrms 
'		NWServ.rtAlarms.refErrorI2 			= NWServ.rtData_s.refErrorI2 
'		NWServ.rtAlarms.refErrorI3 			= NWServ.rtData_s.refErrorI3 
'		NWServ.rtAlarms.refErrorI3 			= NWServ.rtData_s.refErrorI3 
'		
'		NWServ.rtAlarms.refErrorStdDevVrms 	= NWServ.rtData_s.refErrorStdDevVrms 
'		NWServ.rtAlarms.refErrorStdDevI1 	= NWServ.rtData_s.refErrorStdDevI1 
'		NWServ.rtAlarms.refErrorStdDevI2 	= NWServ.rtData_s.refErrorStdDevI2 
'		NWServ.rtAlarms.refErrorStdDevI3 	= NWServ.rtData_s.refErrorStdDevI3 
'		
'		NWServ.rtAlarms.sdCardError 		= NWServ.rtData_s.sdCardError 
'		NWServ.rtAlarms.rtcGPSError 		= NWServ.rtData_s.rtcGPSError 
'		NWServ.rtAlarms.MainBatteryVoltsErr = NWServ.rtData_s.MainBatteryVoltsErr 
'		NWServ.rtAlarms.VBatVoltsErr 		= NWServ.rtData_s.VBatVoltsErr 
'		NWServ.rtAlarms.VRefDiffVoltsErr 	= NWServ.rtData_s.VRefDiffVoltsErr 
'		NWServ.rtAlarms.ProcessorTempErr 	= NWServ.rtData_s.ProcessorTempErr
'		NWServ.rtAlarms.Quality 			= NWServ.rtData_s.Quality
'		NWServ.rtAlarms.PSM_DBConn 			= NWServ.pmonDBIsConnected
'	End If
'End Sub
'
'Sub SetColumnStyle(Index As Int, Style As String, TableView1 As TableView)
'	Dim jo As JavaObject = TableView1
'	Dim Column As JavaObject = jo.RunMethodJO("getColumns", Null).RunMethod("get", Array(Index))
'	Column.RunMethod("setStyle", Array(Style))
'End Sub

'Sub SetCellStyle(Index As Int, Style As String, TableView1 As TableView)
'	Dim jo As JavaObject = TableView1
'	Dim Cell As JavaObject = jo.RunMethodJO("getCell", Null).RunMethod("get", Array(Index))
'	Cell.RunMethod("setStyle", Array(Style))
'End Sub

'Sub CreateRow(Row() As String) As Object()
'	Dim labels(Row.Length) As Object
'	For i = 0 To Row.Length - 1
'		Dim lbl As Label
'		lbl.Initialize("")
'		lbl.Text = Row(i)
'		labels(i) = lbl
'	Next
'	Return labels
'End Sub
'
'Sub initToolBarBtns
'	
'	Dim iv As ImageView
'	iv.Initialize("")
'	
'	'SD Card
'	iv.SetImage(fx.LoadImage(File.DirAssets, "Micro-SD-Card-iconNoStatus.png"))
'	SetGraphic(Main.tb1, iv)
'	iv.PreserveRatio = False
'	iv.SetSize(31, 31)
'	
'	Dim iv As ImageView
'	iv.Initialize("")
'
'	'Tb3 Show alarm table	
'	iv.SetImage(fx.LoadImage(File.DirAssets, "icons8-timezone-+10-80.png"))
'	SetGraphic(Main.tb3, iv)
'	iv.PreserveRatio = False
'	iv.SetSize(35, 35)
'	
'	Dim iv As ImageView
'	iv.Initialize("")
'	
'	'Tb4 Show alarm table
'	iv.SetImage(fx.LoadImage(File.DirAssets, "icons8-speaker-Active-400dpi.png"))
'	SetGraphic(Main.tb4, iv)
'	iv.PreserveRatio = False
'	iv.SetSize(31, 31)
'	
'	Dim iv As ImageView
'	iv.Initialize("")
'	
'	'Tb5 Show alarm table
'	iv.SetImage(fx.LoadImage(File.DirAssets, "AlarmPageHide.png"))
'	SetGraphic(Main.tb5, iv)
'	iv.PreserveRatio = False
'	iv.SetSize(35, 35)
'
'	Dim iv As ImageView
'	iv.Initialize("")
'	
'	'tgbSystemGraphView Show Battery Vols and CPU
'	iv.SetImage(fx.LoadImage(File.DirAssets, "icons8-area-chart-80.png"))
'	SetGraphicToggleBtn(Main.tgbSystemGraphView, iv)
'	iv.PreserveRatio = False
'	iv.SetSize(31, 31)
'	
'	Dim iv As ImageView
'	iv.Initialize("")
'	
'	'tgbZoom
'	iv.SetImage(fx.LoadImage(File.DirAssets, "icons8-zoom-in-80.png"))
'	SetGraphicToggleBtn(Main.tgbZoomBts, iv)
'	iv.PreserveRatio = False
'	iv.SetSize(31, 31)
'End Sub

'Sub initZoomCombos
'	' Do the zoom setting boxes
'	Dim cbList As List
'	Dim cbListItem(6) As String
'
'	cbList.Initialize
'
'	cbListItem(0) = "Default"
'	cbList.Add(cbListItem(0))
'
'	cbListItem(1) = "Increase Top"
'	cbList.Add(cbListItem(1))
'
'	cbListItem(2) = "Reduce Bottom"
'	cbList.Add(cbListItem(2))
'	
'
'	cbListItem(2) = "Wide"
'	cbList.Add(cbListItem(2))
'
'	cbListItem(3) = "Auto"
'	cbList.Add(cbListItem(3))
'
'	Main.b4xCombo_xGraph1_yZoom.SetItems(cbList)
'	Main.b4xCombo_xGraph2_yZoom.SetItems(cbList)
'	
'	'Do the trace selection box xGaraph1
'	Dim cbList As List
'	Dim cbListItem(6) As String
'
'	cbList.Initialize
'	
'	cbListItem(0) = "Voltage RMS"
'	cbList.Add(cbListItem(0))
'
'	cbListItem(1) = "Frequency"
'	cbList.Add(cbListItem(1))
'	Main.b4xCombo_xGraph1_Trace.SetItems(cbList)
'	
'	'Do the trace selection box for xGraph 2
'	Dim cbList As List
'	Dim cbListItem(6) As String
'
'	cbList.Initialize
'	
'	If Main.tgbSystemGraphView.Selected = False Then
'		cbListItem(0) = "Supply kW"
'		cbList.Add(cbListItem(0))
'
'		cbListItem(1) = "Solar  kW"
'		cbList.Add(cbListItem(1))
'
'		cbListItem(3) = "Generator  kW"
'		cbList.Add(cbListItem(3))
'	Else
'		cbListItem(0) = "Main Battery Voltage"
'		cbList.Add(cbListItem(0))
'
'		cbListItem(1) = "CPU Temperature"
'		cbList.Add(cbListItem(1))
'	End If
'	Main.b4xCombo_xGraph2_Trace.SetItems(cbList)
'
'End Sub
'
'Sub SetGraphic(Btn As Button, Graphic As Node)
'	Dim jo As JavaObject = Btn
'	jo.RunMethod("setGraphic", Array(Graphic))
'End Sub
'
'Sub SetGraphicToggleBtn(Btn As ToggleButton, Graphic As Node)
'	Dim jo As JavaObject = Btn
'	jo.RunMethod("setGraphic", Array(Graphic))
'End Sub
'
'Sub setGraphZoomLevel(graphNo As Int, Index As Int)
'	
'	Select Index
'		Case 0  'Default Zoom
'			If graphNo = 1 Then
'				Select Main.b4xCombo_xGraph1_Trace.SelectedIndex
'					Case 0
'						Main.xGraph1.SetScaleManu(0, 220 , 270 )
'					Case 1
'						Main.xGraph1.SetScaleManu(1, 49 , 51 )
'				End Select
'			Else If graphNo = 2 Then
'				If Main.tgbSystemGraphView.Selected = False Then
'					Select Main.b4xCombo_xGraph2_Trace.SelectedIndex
'						Case 0
'							Main.xGraph2.SetScaleManu(0, -10 , 20 )
'						
'						Case 1
'							Main.xGraph2.SetScaleManu(1, 0, 5 )
'						
'						Case 2
'							Main.xGraph2.SetScaleManu(3, 0, 5 )
'						
'					
'					End Select
'				Else
'					Select Main.b4xCombo_xGraph2_Trace.SelectedIndex
'						Case 0
'							Main.xGraph2.SetScaleManu(0, 10, 15 )
'						
'						Case 1
'							Main.xGraph2.SetScaleManu(1, 20, 70 )
'					End Select
'				End If
'			End If
'			
'		Case 1  'Increase Top
'			If graphNo = 1 Then
'				Select Main.b4xCombo_xGraph1_Trace.SelectedIndex
'				Case 0
'				Main.xGraph1.SetScaleManu(0, 220, 300)
'				Case 1
'				Main.xGraph1.SetScaleManu(1, 49, 55)
'				End Select
'			Else If graphNo = 2 Then
'				If Main.tgbSystemGraphView.Selected = False Then
'					Select Main.b4xCombo_xGraph2_Trace.SelectedIndex
'						Case 0
'						Main.xGraph2.SetScaleManu(0, -10 * 1.5, 20 * 1.5)
'						
'						Case 1
'						Main.xGraph2.SetScaleManu(1, 0, 5 * 1.5)
'						
'						Case 2
'						Main.xGraph2.SetScaleManu(3, 0, 5 * 1.5)
'
'					
'					End Select
'				Else
'					Select Main.b4xCombo_xGraph2_Trace.SelectedIndex
'						Case 0
'						Main.xGraph2.SetScaleManu(0, 10, 15 * 1.5)
'						
'						Case 1
'						Main.xGraph2.SetScaleManu(1, 20, 70 * 1.5)
'					End Select
'				End If
'			End If
'
'		Case 2  'Decrease Bottom
'			If graphNo = 1 Then
'				Select Main.b4xCombo_xGraph1_Trace.SelectedIndex
'					Case 0
'						Main.xGraph1.SetScaleManu(0, 150, 270)
'					Case 1
'						Main.xGraph1.SetScaleManu(1, 40, 51)
'				End Select
'			Else If graphNo = 2 Then
'				If Main.tgbSystemGraphView.Selected = False Then
'					Select Main.b4xCombo_xGraph2_Trace.SelectedIndex
'						Case 0
'							Main.xGraph2.SetScaleManu(0, -10 * 2.5, 20 * 2.5)
'						
'						Case 1
'							Main.xGraph2.SetScaleManu(1, 0, 5 * 2.5)
'						
'						Case 2
'							Main.xGraph2.SetScaleManu(3, 0, 5 * 2.5)
'
'					
'					End Select
'				Else
'					Select Main.b4xCombo_xGraph2_Trace.SelectedIndex
'						Case 0
'							Main.xGraph2.SetScaleManu(0, 10, 15 * 2.5)
'						
'						Case 1
'							Main.xGraph2.SetScaleManu(1, 20, 70 * 2.5)
'					End Select
'				End If
'			End If
'
'		Case 3  'Default x 5
'			If graphNo = 1 Then
'				Select Main.b4xCombo_xGraph1_Trace.SelectedIndex
'					Case 0
'						Main.xGraph1.SetScaleManu(0, 0, 300)
'					Case 1
'						Main.xGraph1.SetScaleManu(1, 0, 56)
'				End Select
'			Else If graphNo = 2 Then
'				If Main.tgbSystemGraphView.Selected = False Then
'					Select Main.b4xCombo_xGraph2_Trace.SelectedIndex
'						Case 0
'							Main.xGraph2.SetScaleManu(0, -10 * 5, 20 * 5)
'						
'						Case 1
'							Main.xGraph2.SetScaleManu(1, 0, 5 * 5)
'						
'						Case 2
'							Main.xGraph2.SetScaleManu(3, 0, 5 * 5)
'
'					
'					End Select
'				Else
'					Select Main.b4xCombo_xGraph2_Trace.SelectedIndex
'						Case 0
'							Main.xGraph2.SetScaleManu(0, 10, 15 * 5)
'						
'						Case 1
'							Main.xGraph2.SetScaleManu(1, 20, 70 * 5)
'					End Select
'				End If
'			End If
'		
'		Case 4  'Auto
'			Dim stats As stats_t
'			stats.Initialize
'			
'			If graphNo = 1 Then
'				Select Main.b4xCombo_xGraph1_Trace.SelectedIndex
'					Case 0
'						stats = getDataRange(NWServ.arrayVrms, NWServ.NO_SAMPLES, 0.05)
'						Main.xGraph1.SetScaleManu(0, stats.MinVal, stats.MaxVal)
'					Case 1
'						stats = getDataRange(NWServ.arrayFreq, NWServ.NO_SAMPLES, 0.05)
'						Main.xGraph1.SetScaleManu(1, stats.MinVal, stats.MaxVal)
'				End Select
'			Else If graphNo = 2 Then
'				If Main.tgbSystemGraphView.Selected = False Then
'					Select Main.b4xCombo_xGraph2_Trace.SelectedIndex
'						Case 0
'							stats = getDataRange(NWServ.arraySupplykW, NWServ.NO_SAMPLES, 0.05)
'							Main.xGraph2.SetScaleManu(0, stats.MinVal, stats.MaxVal)
'						
'						Case 1
'							stats = getDataRange(NWServ.arraySolarkW, NWServ.NO_SAMPLES, 0.05)
'							Main.xGraph2.SetScaleManu(1, stats.MinVal, stats.MaxVal)
'						
'						Case 2
'							stats = getDataRange(NWServ.genLoadkW, NWServ.NO_SAMPLES, 0.05)
'							Main.xGraph2.SetScaleManu(3, stats.MinVal, stats.MaxVal)
'					End Select
'				Else
'					Select Main.b4xCombo_xGraph2_Trace.SelectedIndex
'						Case 0
'							stats = getDataRange(NWServ.arrayMainBatVolts, NWServ.NO_SAMPLES, 0.05)
'							Main.xGraph2.SetScaleManu(0, stats.MinVal, stats.MaxVal)
'						
'						Case 1
'							stats = getDataRange(NWServ.arrayCPUTemp, NWServ.NO_SAMPLES, 0.05)
'							Main.xGraph2.SetScaleManu(1, stats.MinVal, stats.MaxVal)
'					End Select
'				End If	
'			End If
'		Case Else
'	End Select
'End Sub
'
'
'
'Sub b4xCombo_xGraph2_Trace_SelectedIndexChanged (Index As Int)
'	
'End Sub
'
'Sub b4xCombo_xGraph1_Trace_SelectedIndexChanged (Index As Int)
'	
'End Sub
'


'Sub getDataRange(traceData() As Double, length As Int,  yInc As Double) As stats_t
'	Dim statsTemp As stats_t
'	
'	statsTemp.Initialize
'	statsTemp.MaxVal = -1e100
'	statsTemp.MinVal =  1e100
'	
'	For i = 0 To length - 1
'		If traceData(i) > statsTemp.MaxVal Then statsTemp.MaxVal = traceData(i)
'		If traceData(i) < statsTemp.MinVal Then statsTemp.MinVal = traceData(i)
'	Next
'	statsTemp.range = Abs(statsTemp.MaxVal - statsTemp.MinVal)
'	statsTemp.MaxVal = statsTemp.MaxVal + yInc * statsTemp.range
'	statsTemp.MinVal = statsTemp.MinVal + yInc * statsTemp.range
'	Return statsTemp
'End Sub
'
















